-- Written by Merkal @ Andorhal


srfTortos = sRaidFrames:NewModule("srfTortos", "AceEvent-3.0")

local SPELL_SHIELD, SPELL_SHIELD_FULL = GetSpellInfo(137633), GetSpellInfo(140701)

local cshell_status = "Crystal Shell"

local numGrouopMembers
local tracking = false
local unitHasShield = {}


function srfTortos:OnInitialize()
   sRaidFrames:AddStatusMap(cshell_status, 30, {}, "-5%", {r=0, g=1, b=1, a=0})
end

function srfTortos:OnEnable()
   self:UpdateRoster()
   self:RegisterEvent("ZONE_CHANGED", "UpdateTracking")
   self:RegisterEvent("ZONE_CHANGED_INDOORS", "UpdateTracking")
   self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "UpdateTracking")
   self:UpdateTracking()

end

function srfTortos:OnDisable()
   self:UnregisterEvent("ZONE_CHANGED")
   self:UnregisterEvent("ZONE_CHANGED_INDOORS")
   self:UnregisterEvent("ZONE_CHANGED_NEW_AREA")
end


function srfTortos:UpdateRoster()
   numGroupMembers = GetNumGroupMembers()
end


function srfTortos:UpdateTracking()
   local should_track = (GetMapInfo() == "ThunderKingRaid")
   if should_track ~= tracking then
      if tracking then
	 -- Ends tracking
	 --print("Tortos Shield: stop tracking")
	 self:Reset()
      else
	 -- Start tracking
	 --print("Tortos Shield: start tracking")
	 self:RegisterMessage("GROUP_ROSTER_UPDATE", "UpdateAllUnits")
	 self:RegisterEvent("UNIT_MAXHEALTH", "UpdateUnit")
	 self:RegisterEvent("UNIT_ABSORB_AMOUNT_CHANGED", "UpdateUnit")
	 self:UpdateAllUnits()
      end
      tracking = should_track
   end
end

function srfTortos:Reset()
   for i=1, numGroupMembers do
      sRaidFrames:UnsetStatus(unitid, cshell_status)
   end
	
   self:UnregisterMessage("GROUP_ROSTER_UPDATE")
   self:UnregisterEvent("UNIT_MAXHEALTH")
   self:UnregisterEvent("UNIT_ABSORB_AMOUNT_CHANGED")
   tracking = false
	
   unitHasShield = {}
end

function srfTortos:UpdateUnit(_, unitid)
   self:UpdateUnitShield(unitid)
end

function srfTortos:UpdateAllUnits()
   for idno=1, numGroupMembers do
      self:UpdateUnitShield("raid"..idno)
   end
end


function srfTortos:UpdateUnitShield(unitid)
   local shield = select(15, UnitDebuff(unitid, SPELL_SHIELD))
   local guid = UnitGUID(unitid)
   
   if not shield then
      if unitHasShield[guid] then
	 unitHasShield[guid] = nil
	 sRaidFrames:UnsetStatus(unitid, cshell_status)
      end
      return
   elseif not unitHasShield[guid] then
      unitHasShield[guid] = true
   end
   
   local shieldFull = UnitDebuff(unitid, SPELL_SHIELD_FULL)
   local maxShield = UnitHealthMax(unitid) * 0.75
   
   print(unitid, shieldFull, shield, maxShield)
   sRaidFrames:SetStatus(unitid, 
			 cshell_status,
			 shieldFull and 100 or (math.floor((shield / maxShield) * 99) + 1),
			 {r=1, b=1, g=1}, 
			 true)
end
